#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include "buffer.h"
#include "stralloc.h"
#include "dnsresolv.h"
#include "ip.h"
#include "exit.h"
#include "fmt.h"
#include "dns.h"
#include "logmsg.h"

#define WHO "dnsip"

stralloc sa = {0};
stralloc out = {0};

int main(int argc, char **argv)
{
  int i;
  char ip4str[IP4_FMT];
  char ip6str[IP6_FMT];

  if (!argv[1])
    logmsg(WHO,100,USAGE,"dnsip fqdn");

  if (!stralloc_copys(&sa,argv[1]))
    logmsg(WHO,111,FATAL,"out of memory");

  DNS_INIT
  if (dns_ip6(&out,&sa) > 0)		/* IPv6 first */
    for (i = 0; i + 16 <= out.len; i += 16) {
     if (ip6_isv4mapped(out.s + i)) continue;
      buffer_put(buffer_1,ip6str,ip6_fmt(ip6str,out.s + i));
      buffer_puts(buffer_1,"\n");
    }

  if (dns_ip4(&out,&sa) > 0)
    for (i = 0; i + 4 <= out.len;i += 4) {
       buffer_put(buffer_1,ip4str,ip4_fmt(ip4str,out.s + i));
       buffer_puts(buffer_1,"\n");
    }
  buffer_putsflush(buffer_1,"");

  _exit(0);
}
