#include <unistd.h>
#include "tls_errors.h"
#include "error.h"

/** @file tls_errors.c 
    @brief temp_tls* routines are used for error messges
*/

/* TLS error messages: A) Connection related */

void temp_tlsctx() 
{ 
  out("ZI wasn't able to create TLS context for: ");
  outsafe(&host); 
  out(". (#4.4.1)\n"); 
  zerodie();
}

void temp_tlscon() 
{ 
  errno = EPROTO;
  out("ZI wasn't able to establish a TLS connection with: "); 
  outsafe(&host); 
  out(". (#4.4.1)\n"); 
  zerodie(); 
}

void temp_tlserr() 
{
  errno = EPROTO;
  out("ZTLS connection/protocol error for host: ");
  outsafe(&host);
  out(". (#4.4.1)\n");
  zerodie();
}

void temp_tlshost() 
{ 
  out("ZI wasn't able to negotiate a TLS connection with: "); 
  outsafe(&host); 
  out(". (#4.4.1)\n"); 
  zerodie(); 
}

/* TLS error messages: B) Cipher related */

void temp_tlscipher() 
{
    out("ZI wasn't able to process the TLS ciphers: ");
    outsafe(&ciphers);
    out(" (#4.4.1)\n");
    zerodie();
}

/* TLS error messages: C) Server cert related */

void temp_tlsca() 
{ 
  out("ZI wasn't able to set up CAFILE: "); 
  outsafe(&cafile); 
  out(" or CADIR: ");
  outsafe(&cadir); 
  out(" for TLS. (#4.4.1)\n"); 
  zerodie(); 
}

void temp_tlspeercert() 
{ 
  out("ZUnable to obtain X.500 certificate from: "); 
  outsafe(&host); 
  out(". (#4.4.1)\n"); 
  zerodie(); 
}

void temp_tlspeerverify() 
{ 
  out("ZUnable to verify X.500 certificate from: "); 
  outsafe(&host); 
  out(". (#4.4.1)\n"); 
  zerodie(); 
}

void temp_tlspeervalid() 
{ 
  out("ZUnable to validate X.500 certificate Subject for: "); 
  outsafe(&host); 
  out(". (#4.4.1)\n"); 
  zerodie(); 
}

void temp_tlscertfp() 
{ 
  out("ZReceived X.509 certificate from: ");
  outsafe(&host); 
  out(" does not match fingerprint: "); 
  outsafe(&cafile); 
  out(". (#4.4.1)\n"); zerodie(); 
}

void temp_invaliddigest() 
{ 
  out("ZInvalid digest length provided for: ");
  outsafe(&host); 
  out(". (#4.4.1)\n"); zerodie(); 
}

void temp_tlsdigest() 
{ 
  out("ZReceived X.509 certificate from: ");
  outsafe(&host); 
  out(" posses an unknown digest method"); 
  out(". (#4.4.1)\n"); zerodie(); 
}

/* TLS error messages: D) Client cert related */

void temp_tlscert() 
{ 
  out("ZCan't load X.509 certificate: "); 
  outsafe(&certfile); 
  out(". (#4.4.1)\n"); zerodie(); 
}

void temp_tlskey() 
{ 
  out("ZCan't load X.509 private key: "); 
  outsafe(&keyfile); 
  out(". (#4.4.1)\n"); 
  zerodie(); 
}

void temp_tlschk() 
{ 
  out("ZKeyfile does not match X.509 certificate: "); 
  outsafe(&keypwd); 
  out(". (#4.4.1)\n"); 
  zerodie(); 
}
